#!/bin/bash

# 该脚本为K8S扩容脚本
# 入参示例： 2 10.0.221.8,root,root,22 10.0.221.9,root,root,22

sh_dir=$(cd "$(dirname "${BASH_SOURCE[0]}")" &> /dev/null && pwd)
cd $sh_dir
source ./base.sh


OLD_NODE_SSH_INFO="$NODE_SSH_INFO"

# 生成新的节点信息
EXPAND_NODE_SSH_INFO=cluster-nodes-ssh-info-$(date +"%Y-%m-%d_%H-%M-%S")
echo '# <host> <username> <password> <port> <path>' > "$EXPAND_NODE_SSH_INFO"
host_count=$1
shift
for ((i=1; i<=$host_count; i++)); do
    IFS=',' read -r host username password port <<< "$1"
    echo "$host $username $password $port" >> "$EXPAND_NODE_SSH_INFO"
    shift
done

# 修改配置文件
sed -i "s/^NODE_SSH_INFO=.*/NODE_SSH_INFO=$EXPAND_NODE_SSH_INFO/" config

# 授信
bash node-authentication.sh


# 传输安装包到新节点上
bash node-distribute.sh

# 安装docker，加载镜像，安装k8s
retrieve_node_ssh_info_in_background run_script_on_remote init-env.sh



# 新节点join集群
join_command=$(sudo kubeadm token create --print-join-command )
echo "sudo $join_command --ignore-preflight-errors=all" | tee join-kubernetes.sh
retrieve_node_ssh_info copy_file_to_remote_same_path join-kubernetes.sh
retrieve_node_ssh_info run_script_on_remote join-kubernetes.sh

# 把配置文件改回去
sed -i "s/^NODE_SSH_INFO=.*/NODE_SSH_INFO=$OLD_NODE_SSH_INFO/" config