#!/usr/bin/env bash

# 脚本所在位置
sh_dir=$(cd "$(dirname "${BASH_SOURCE[0]}")" &> /dev/null && pwd)
cd $sh_dir
source ./base.sh

retrieve_node_ssh_info 'one_hostname=$(ssh_cmd -p$node_port -n $node_user@$node_ip hostname) \
                        && echo "$node_ip $one_hostname" \
                        && all_node_hostnames="$all_node_hostnames $one_hostname" \
                        && all_node_ips="$all_node_ips $node_ip"'

read -a hostname_list <<< "$all_node_hostnames"

declare -A hostname_collection

found=0
for one_hostname in "${hostname_list[@]}"; do
    if [[ -n "${hostname_collection[$one_hostname]}" ]]; then
        found=1
        break
    fi
    hostname_collection["$one_hostname"]=1
done

if [[ $found -eq 0 ]]; then
  echo "every hostname of cluster nodes is unique!"
  exit 0
fi

echo "duplicate hostname found, please set hostname below!"

new_hostnames=""
hostname_num=0
append_hosts=""
for one_ip in $all_node_ips; do
    read -p "Enter new hostname for $one_ip (left empty to use original hostname): " one_new_hostname
    if [[ -z $one_new_hostname ]]; then
        new_hostnames="$new_hostnames ${hostname_list[$hostname_num]}"
    else
        new_hostnames="$new_hostnames $one_new_hostname"
    fi
    append_hosts="$append_hosts\n$one_ip $one_new_hostname"
done
read -a new_hostname_list <<< "$new_hostnames"

retrieve_node_ssh_info 'ssh_cmd -p$node_port -n $node_user@$node_ip "sudo hostnamectl set-hostname ${new_hostname_list[$LINE_NUM]} --static --transient \
                        && echo -e \"$append_hosts\" | sudo tee -a /etc/hosts"'
bash hostname-check-set.sh