#!/usr/bin/env bash

# 脚本所在位置
sh_dir=$(cd "$(dirname "${BASH_SOURCE[0]}")" &> /dev/null && pwd)
cd $sh_dir
source ./base.sh

# 删除重复的密钥对
rm -f "$NODE_SSH_KEY_PATH" "$NODE_SSH_KEY_PATH.pub"
# 生成密钥对，类型ecdsa，长度256位，格式PEM，指定目标文件，不设置密码
ssh-keygen -t ecdsa -b 256 -f "$NODE_SSH_KEY_PATH" -N '' -m PEM <<< "y"

# 需要使用expect命令
if [[ -z $(command -v expect) ]]; then
    install_package "$EXPECT_PACKAGE_DIR" "$EXPECT_VERSION"
fi

# 针对可能遇到spawn id exp6 not open，临时忽略
set +e

# 遍历集群节点的ssh信息，逐个执行期望脚本，将本地的公钥复制到远程机器上，完成机器之间的认证互信
retrieve_node_ssh_info copy_public_key_to_remote $NODE_SSH_EXPECT_SCRIPT

# 认证结束后恢复
set -e
