#!/usr/bin/env bash

# 脚本所在位置
sh_dir=$(cd "$(dirname "${BASH_SOURCE[0]}")" &> /dev/null && pwd)
cd $sh_dir
source ./base.sh

# 脚本拷贝到远程机器上
retrieve_node_ssh_info_in_background copy_file_to_remote $sh_dir

if [[ ${1:-1} -eq 1 ]]; then
    # 仅当安装时需要传输软件包
    retrieve_node_ssh_info_in_background rsync_file_to_remote $BASE_PACKAGES_DIR

    # 安装rsync
    retrieve_node_ssh_info_in_background run_script_on_remote install-rsync.sh

    # 再把镜像包拷贝到远程机器上
    retrieve_node_ssh_info_in_background rsync_file_to_remote $DOCKER_IMAGES_DIR --exclude 'master/'

    # 最后把主节点所需镜像包拷贝到主节点上
    handle_first_node_ssh_info rsync_file_to_remote $DOCKER_IMAGES_DIR
fi