#!/usr/bin/env bash

# 脚本所在位置
sh_dir=$(cd "$(dirname "${BASH_SOURCE[0]}")" &> /dev/null && pwd)
cd $sh_dir
source ./base.sh

# 输出要删除环境的节点信息，并倒计时10秒
echo "Start to remove environment in nodes below, press Ctrl+C to interrupt this execution!"
retrieve_node_ssh_info 'echo $node_ip'
echo "Count down 10 seconds!"
count_down 10

if [[ ${SKIP_NODE_AUTHENTICATION:-0} -eq 1 ]]; then
    echo "SKIP_NODE_AUTHENTICATION is set to 1, will not handle node ssh authentication!"
else
    # 需要使用expect命令
    if [[ -z $(command -v expect) ]]; then
        install_package "$EXPECT_PACKAGE_DIR" "$EXPECT_VERSION"
    fi

    # 执行主节点->从节点的SSH认证互信（单向）
    bash node-authentication.sh
fi

if [[ ${SKIP_NODE_DISTRIBUTE:-0} -eq 1 ]]; then
    echo "SKIP_NODE_DISTRIBUTE is set to 1, will not distribute files to node!"
else
    # 执行所有节点文件分发
    bash node-distribute.sh 0
fi

retrieve_node_ssh_info_in_background 'ssh_cmd -p$node_port -n $node_user@$node_ip "bash $node_path/script/remove-env.sh"'
